#include <stdio.h>
#include <string.h>
#include <sys/stat.h>

//#include <sys/mman.h>
//#include <sys/syscall.h>

#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <SDL/SDL_image.h>

#define SCREEN_WIDTH		(1920/2)
#define SCREEN_HEIGHT	(1080/2)
#define SCREEN_BPP	32

static SDL_Surface *screen = NULL;
static SDL_Surface *btsu = NULL;
static SDL_Surface * bg = NULL;
TTF_Font *font;
TTF_Font *font14;
TTF_Font *font24;
//------------------------------------------------------------------------------
void CleanUp(void)
{
	if (font) TTF_CloseFont(font);
	if (font14) TTF_CloseFont(font14);
   if (font24) TTF_CloseFont(font24);
   SDL_Quit();
}
//------------------------------------------------------------------------------

int _sdl_init()
{
	SDL_Surface *screen;	//This pointer will reference the backbuffer

	
	//We must first initialize the SDL video component, and check for success
	if (SDL_Init(SDL_INIT_VIDEO) != 0) {
		printf("Unable to initialize SDL: %s\n", SDL_GetError());
		return 1;
	}
	//When this program exits, SDL_Quit must be called
	//atexit(SDL_Quit);
	

	//Return success!
	return 0;	

	}

////code from deny START

void sdl_draw_text(int x, int y, char *msg, int len_cut , unsigned char flip)
{
#if 1
	char tempstr[100];
	int width = 10, height = 10,w = 0;	
	memset(tempstr, 0, 100);
	
	if (len_cut) 
		strncpy(tempstr,msg, len_cut);
	else 
		strcpy(tempstr,msg);

	TTF_SizeText( font14, tempstr, &w,&height );
	SDL_Color c_yellow={ 255, 255, 0 };
	SDL_Rect dstrect = { x + width/2-w/2, y, 0, 0 }; //centruoja!
//	SDL_Rect dstrect = { x, y, 0, 0 };

	btsu=TTF_RenderText_Solid(font14, tempstr ,  c_yellow);
	SDL_BlitSurface(btsu, NULL, screen, &dstrect);
	SDL_FreeSurface(btsu);  
	if (flip == 1)
		SDL_Flip(screen);
#endif
}

void sdl_draw_text_blue_c(int x, int y, char *msg, int len_cut , unsigned char flip)
{
#if 1
	char tempstr[100];
	int width = 10, height = 10,w = 0;	
	memset(tempstr, 0, 100);
	
	if (len_cut) 
		strncpy(tempstr,msg, len_cut);
	else 
		strcpy(tempstr,msg);

	TTF_SizeText( font14, tempstr, &w,&height );
	SDL_Color c_yellow={ 0, 255, 255 };
	SDL_Rect dstrect = { x + width/2-w/2, y, 0, 0 }; //centruoja!
//	SDL_Rect dstrect = { x, y, 0, 0 };

	btsu=TTF_RenderText_Solid(font14, tempstr ,  c_yellow);
	SDL_BlitSurface(btsu, NULL, screen, &dstrect);
	SDL_FreeSurface(btsu);  
	if (flip == 1)
		SDL_Flip(screen);
#endif
}

void sdl_draw_text_yellow(int x, int y, char *msg, int len_cut , unsigned char flip)
{
#if 1
	char tempstr[100];
	int width = 10, height = 10,w = 0;	
	memset(tempstr, 0, 100);
	
	if (len_cut) 
		strncpy(tempstr,msg, len_cut);
	else 
		strcpy(tempstr,msg);

	TTF_SizeText( font14, tempstr, &w,&height );
	SDL_Color c_yellow={ 200, 200, 100 };
//	SDL_Rect dstrect = { x + width/2-w/2, y, 0, 0 }; //centruoja!
	SDL_Rect dstrect = { x, y, 0, 0 };

	btsu=TTF_RenderText_Solid(font14, tempstr ,  c_yellow);
	SDL_BlitSurface(btsu, NULL, screen, &dstrect);
	SDL_FreeSurface(btsu);  
	if (flip == 1)
		SDL_Flip(screen);
#endif
}
void sdl_draw_text_red(int x, int y, char *msg, int len_cut , unsigned char flip)
{
#if 1
	char tempstr[100];
	int width = 10, height = 10,w = 0;	
	memset(tempstr, 0, 100);
	
	if (len_cut) 
		strncpy(tempstr,msg, len_cut);
	else 
		strcpy(tempstr,msg);

	TTF_SizeText( font14, tempstr, &w,&height );
	SDL_Color c_yellow={ 200, 10, 10 };
//	SDL_Rect dstrect = { x + width/2-w/2, y, 0, 0 }; //centruoja!
	SDL_Rect dstrect = { x, y, 0, 0 };

	btsu=TTF_RenderText_Solid(font14, tempstr ,  c_yellow);
	SDL_BlitSurface(btsu, NULL, screen, &dstrect);
	SDL_FreeSurface(btsu);  
	if (flip == 1)
		SDL_Flip(screen);
#endif
}

void sdl_draw_text_green(int x, int y, char *msg, int len_cut , unsigned char flip)
{
#if 1
	char tempstr[100];
	int width = 10, height = 10,w = 0;	
	memset(tempstr, 0, 100);
	
	if (len_cut) 
		strncpy(tempstr,msg, len_cut);
	else 
		strcpy(tempstr,msg);

	TTF_SizeText( font14, tempstr, &w,&height );
	SDL_Color c_yellow={ 10, 200, 10 };
//	SDL_Rect dstrect = { x + width/2-w/2, y, 0, 0 }; //centruoja!
	SDL_Rect dstrect = { x, y, 0, 0 };

	btsu=TTF_RenderText_Solid(font14, tempstr ,  c_yellow);
	SDL_BlitSurface(btsu, NULL, screen, &dstrect);
	SDL_FreeSurface(btsu);  
	if (flip == 1)
		SDL_Flip(screen);
#endif
}

void sdl_draw_text_blue(int x, int y, char *msg, int len_cut , unsigned char flip)
{
#if 1
	char tempstr[100];
	int width = 10, height = 10,w = 0;	
	memset(tempstr, 0, 100);
	
	if (len_cut) 
		strncpy(tempstr,msg, len_cut);
	else 
		strcpy(tempstr,msg);

	TTF_SizeText( font14, tempstr, &w,&height );
	SDL_Color c_yellow={ 10, 255, 255 };
//	SDL_Rect dstrect = { x + width/2-w/2, y, 0, 0 }; //centruoja!
	SDL_Rect dstrect = { x, y, 0, 0 };

	btsu=TTF_RenderText_Solid(font14, tempstr ,  c_yellow);
	SDL_BlitSurface(btsu, NULL, screen, &dstrect);
	SDL_FreeSurface(btsu);  
	if (flip == 1)
		SDL_Flip(screen);
#endif
}

void sdl_draw_text2(int x, int y, char *msg, int len_cut, unsigned char flip)
{
#if 1
	char tempstr[100];
	int  height = 10,w = 0;
	memset(tempstr, 0, 100);
	
	if (len_cut) 
		strncpy(tempstr,msg, len_cut);
	else 
		strcpy(tempstr,msg);
	
	TTF_SizeText( font14, tempstr, &w,&height );

	SDL_Color c_yellow={ 255, 255, 0 };
	SDL_Rect dstrect = { x , y, 0, 0 };

	btsu=TTF_RenderText_Solid(font14, tempstr ,  c_yellow);
	SDL_BlitSurface(btsu, NULL, screen, &dstrect);
	SDL_FreeSurface(btsu);  
	if (flip == 1)
		SDL_Flip(screen);
#endif
}


void sdl_draw_text24(int x, int y, char *msg, unsigned char flip)
{
#if 1
	int width = 10, height = 10,  w = 0;
	TTF_SizeText( font24, msg, &w,&height );
	SDL_Color c_yellow={ 255, 255, 0 };
   
	SDL_Rect dstrect = {x + width/2-w/2, y, 0, 0 };

	btsu=TTF_RenderText_Solid(font24, msg ,  c_yellow);
	SDL_BlitSurface(btsu, NULL, screen, &dstrect);
	SDL_FreeSurface(btsu);  
	if (flip == 1)
		SDL_Flip(screen);
#endif
}

void sdl_draw_text24_red(int x, int y, char *msg, unsigned char flip)
{
#if 1
	int width = 10, height = 10,  w = 0;
	TTF_SizeText( font24, msg, &w,&height );
	SDL_Color c_yellow={ 200, 0, 0 };
   
	SDL_Rect dstrect = {x + width/2-w/2, y, 0, 0 };

	btsu=TTF_RenderText_Solid(font24, msg ,  c_yellow);
	SDL_BlitSurface(btsu, NULL, screen, &dstrect);
	SDL_FreeSurface(btsu);  
	if (flip == 1)
		SDL_Flip(screen);
#endif
}
void sdl_draw_text_1(int x, int y, char *msg, int len_cut)
{
   
	int width = 10, height = 10;
	int n = 0;
	int w = 0;
	char tempstr[100];
	
	memset(tempstr, 0, 100);
	if (len_cut) 
		strncpy(tempstr,msg, len_cut);
	else 
		strcpy(tempstr,msg);
		
	TTF_SizeText( font14, tempstr, &w,&height );
	SDL_Color c_black={ 0, 0, 0 };
	SDL_Color c_yellow={ 1, 1, 0 };
	SDL_Rect dstrect = { x + width/2-w/2, y, 0, 0 };
	btsu=TTF_RenderText_Solid(font14, tempstr ,  c_yellow);
	SDL_BlitSurface(btsu, NULL, screen, &dstrect);
	SDL_FreeSurface(btsu);  
}

////code from deny END
	
	
	
// main function
int Game_Main(const char *path, const char *udn __attribute__ ((unused)))
{
	SDL_Surface *bg;	//This pointer will reference our bitmap sprite
	SDL_Surface *tempImage;	//This pointer will temporarily reference our bitmap sprite
	SDL_Rect src, dest;	//These rectangles will describe the source and destination regions of our blit
	char file[100];

	char *fpath="./res/ttx.ttf";
   char str[100];
	struct stat sts;
   int fsize;
//	char *fsize=16;
	char cmd[200];//, mtxt[200];
        chdir(path); //change path to current
		_sdl_init();

	//Set the video mode to fullscreen 960x540 with 32bit colour and half-buffering
	//Screen Setup
   screen=SDL_SetVideoMode(1920/2, 1080/2, 32, SDL_HWSURFACE);
	if (screen == NULL) {
		printf("Unable to set video mode: %s\n", SDL_GetError());
		return 1;
	}

	SDL_FillRect( screen , &screen->clip_rect ,  SDL_MapRGB( screen->format , 0xFF, 0xFF, 0xFF ) );	

   if((TTF_Init() != 0) || ((font=TTF_OpenFont(fpath, fsize)) == NULL))
      {
       //font bad or damaged
       SDL_Quit();
       return(4);
      }	

   if(stat(fpath, &sts) != 0)
     {
      //font not found
           return(1);
		   SDL_Quit();
     }
	
   if(fsize == 0)
      {
       fsize=16; //Font size
      }	
	 
//	 TTF_Init();
	sprintf(file, "./res/ttx.ttf", path );
	font=TTF_OpenFont(file, 12);
	font14=TTF_OpenFont(file, 14);
	font24=TTF_OpenFont(file, 24);

/*	
	//Load the bitmap into a temporary surface, and check for success
	temp = SDL_LoadBMP("./bg_s.bmp");
	if (temp == NULL) {
		printf("Unable to load bitmap: %s\n", SDL_GetError());
		return 1;
	}	
*/
	sprintf(str, "./res/bg_s.bmp", path);
	tempImage = SDL_LoadBMP(str);
	if (tempImage) {
		bg = SDL_DisplayFormat(tempImage);
	} else {
		mcas_debug("error loading bg.bmp\n");
 		CleanUp();
		return (5);	
	}
	
	//Release the temporary surface
	SDL_FreeSurface(tempImage);

	//Construct the source rectangle for our blit
	src.x = 0;
	src.y = 0;
	src.w = bg->w;	//Use image->w to display the entire width of the image
	src.h = bg->h;	//Use image->h to display the entire height of the image
	
	//Construct the destination rectangle for our blit
	//dest.x = 100;		//Display the image at the (X,Y) coordinates (100,100)
	//dest.y = 100;
	dest.x = 0;		//Display the image at the (X,Y) coordinates (100,100)
	dest.y = 0;	
	dest.w = bg->w;	//Ensure the destination is large enough for the image's entire width/height
	dest.h = bg->h;
    //Blit the image to the backbuffer
    SDL_BlitSurface(bg, &src, screen, &dest);
  
    //Flip the backbuffer to the primary
    SDL_Flip(screen);

/*        switch (_sdl_init())
        {
          case 0: sprintf(cmd, "./ok.sh %s &", path);
          break;
          case 1: sprintf(cmd, "./1.sh %s &", path);
          break;
          case 2: sprintf(cmd, "./2.sh %s &", path);
          break;
          case 3: sprintf(cmd, "./3.sh %s &", path);
          break;
          case 4: sprintf(cmd, "./4.sh %s &", path);
          break;
        }
        system(cmd);
*/
//Starting ffb game script
	sprintf(cmd, "chmod 0755 ./*.sh");
	system(cmd);
	sprintf(cmd, "./ffb.sh %s &", path);        //execute bash script
	system(cmd);

	// main game loop
  int playing = 1;

  while(playing) {
// My code here START ==============================
	sdl_draw_text24(1920/3 + 200,460 , "SamyGO@TV", 1);
	sdl_draw_text24_red(1920/3 + 200, 35, "CI mode", 1);
	sdl_draw_text_blue_c(1920/3 + 200,10 , "FFB v0.8",0, 1);
	sdl_draw_text(1920/3 + 200, 460 + 30, "11/11/2012",0, 1);

	
	sdl_draw_text(170, 10, "FIRMWARE DOWNGRADING",0, 1);
//	sleep(1);
	sdl_draw_text(170, 30, " B series Samsung TV ",0, 1);
//	sleep(1);  
//Firmware on USB mach to firmware on TV
    if(!stat("/dtv/script_start", &sts))
        {
//progress...
		sdl_draw_text_green(35,70, "[                     ]",0, 1);
	//system("rm -rf /dtv/script_start");
		sleep(3);
        }	
	
//Error: No valid USB detected
    if(!stat("/dtv/NO_USB", &sts))
        {
		sdl_draw_text_red(20,100, "ERROR: No valid USB found !!!",0, 1);
		sdl_draw_text_green(60,70, "*",0, 1);
		usleep(1000*500);
		sdl_draw_text_green(20,100+20, "Try another USB disk.",0, 1);
		sdl_draw_text_red(20,100+40 , "Rebooting...",0, 1);
		usleep(500*500); 
	//system("rm -rf /dtv/NO_USB");
        }
	
//Error: Not fat32, wrong usb filesystem
	if(!stat("/dtv/0_wrong_usb_fs", &sts))
        {
		sdl_draw_text_red(20,100, "ERROR: NTFS usb disk!!!",0, 1);
		sdl_draw_text_green(60,70, "*",0, 1);
		usleep(1000*500);
		sdl_draw_text_yellow(20,100+20, "Only FAT32 is accepted.",0, 1);
		sdl_draw_text_red(20,100+40 , "Rebooting...",0, 1);
		usleep(500*500); 
	//system("rm -rf /dtv/0_wrong_usb_fs");
        }	
	
//Error: No firmware or wrong firmware on USB
	if(!stat("/dtv/1_no_fw_on_usb", &sts))
        {
		sdl_draw_text_red(20,100, "ERROR: No proper firmware on USB found!!!",0, 1);
		sdl_draw_text_green(60,70, "*",0, 1);
		usleep(1000*500);
		sdl_draw_text_red(20,100+40 , "Rebooting...",0, 1);
		usleep(500*500);  
	//system("rm -rf /dtv/1_no_fw_on_usb");
        }		

//Firmware on USB mach to firmware on TV
    if(!stat("/dtv/2_fw_ok", &sts))
        {
		sdl_draw_text_green(20,100, "Firmware on USB...",0, 1);
		usleep(1000*500);
		sdl_draw_text_green(20+280,100, "OK",0, 1);
		usleep(500*500);
//progress...
		sdl_draw_text_green(60,70, "*",0, 1);
	//system("rm -rf /dtv/2_fw_ok");
        }		


		
//Error: Firmware on USB differs from firmware on TV		
    if(!stat("/dtv/3_fw_mismatch", &sts))
        {
		sdl_draw_text_red(20+280,100, "failed",0, 1);
		sdl_draw_text_red(20,100+40, "ERROR: Wrong firmware on USB!",0, 1);
		sdl_draw_text_red(20,100+60 , "Do you want brick your TV ???",0, 1);
		usleep(1000*500);
		sdl_draw_text_red(20,100+80 , "Rebooting...",0, 1);
		usleep(500*500); 
	//system("rm -rf /dtv/3_fw_mismatch");
		}	

//Error: md5sum binary not found	
		if(!stat("/dtv/4_no_md5sum", &sts))
        {
		sdl_draw_text_red(20,100+40, "ERROR: missing md5sum!",0, 1);
		usleep(1000*500);
		sdl_draw_text_yellow(20,100+60, "Please use only latest FFB version.",0, 1);
		usleep(1000*500);  
		sdl_draw_text_red(20,100+80 , "Rebooting...",0, 1);
		usleep(500*500); 
	//system("rm -rf /dtv/4_no_md5sum");
        }	
		
//Error: crc binary not found	
		if(!stat("/dtv/4_no_crc", &sts))
        {
		sdl_draw_text_red(20,100+40, "ERROR: missing crc!",0, 1);
		usleep(1000*500);
		sdl_draw_text_yellow(20,100+60, "Please use only latest FFB version.",0, 1);
		usleep(1000*500);  
		sdl_draw_text_red(20,100+80 , "Rebooting...",0, 1);
		usleep(500*500); 
	//system("rm -rf /dtv/4_no_crc");
        }		
		
//Error: ddcmp binary not found	
		if(!stat("/dtv/4_no_ddcmp", &sts))
        {
		sdl_draw_text_red(20,100+40, "ERROR: missing ddcmp!",0, 1);
		usleep(1000*500);
		sdl_draw_text_yellow(20,100+60, "Please use only latest FFB version.",0, 1);
		usleep(1000*500); 
		sdl_draw_text_red(20,100+80 , "Rebooting...",0, 1);
		usleep(500*500);  
	//system("rm -rf /dtv/4_no_ddcmp");
        }	
		
//u-boot, image, fnw md5sum failed
	if(!stat("/dtv/md5_error", &sts))
        {
		sdl_draw_text_red(20,100+40, "ERROR: wrong checksums!",0, 1);
		usleep(1000*500);
		sdl_draw_text_yellow(20,100+60, "Wrong u-boot, Image, fwn.bin used.",0, 1);
		usleep(1000*500);  
		sdl_draw_text_red(20,100+80 , "Rebooting...",0, 1);
		usleep(500*500);  
	//system("rm -rf /dtv/md5_error");
        }		
//Progress: uboot:
    if(!stat("/dtv/u_boot_start", &sts))
        {
		sdl_draw_text_green(20,100+20, "Flashing u-boot...",0, 1);
		usleep(500*500); 
//progress...
		sdl_draw_text_green(60,70, "**",0, 1);
	//system("rm -rf /dtv/u_boot_start");
        }	
		
    if(!stat("/dtv/u_boot_ok", &sts))
        {
		sdl_draw_text_green(20+280,100+20, "OK",0, 1);
		usleep(500*500); 
		sdl_draw_text_green(60,70, "***",0, 1);
	//system("rm -rf /dtv/u_boot_ok");
        }	

//Error: no u-boot	
		if(!stat("/dtv/no_u_boot", &sts))
        {
		sdl_draw_text_red(20,100+40, "ERROR: missing u-boot.bin!",0, 1);
		usleep(1000*500);
		sdl_draw_text_yellow(20,100+60, "Please check instructions.",0, 1);
		usleep(1000*500);  
		sdl_draw_text_red(20,100+80 , "Rebooting...",0, 1);
		usleep(500*500); 
	//system("rm -rf /dtv/no_u_boot");
        }		
//Progress: fnw:
    if(!stat("/dtv/fnw_start", &sts))
        {
		sdl_draw_text_green(20,100+40, "Flashing fnw...",0, 1);
		usleep(500*500); 
//progress...
		sdl_draw_text_green(60,70, "****",0, 1);
	//system("rm -rf /dtv/fnw_start");
        }	
				
    if(!stat("/dtv/fnw_ok", &sts))
        {
		sdl_draw_text_green(20+280,100+40, "OK",0, 1);
		usleep(500*500); 
//progress...
		sdl_draw_text_green(60,70, "*****",0, 1);
	//system("rm -rf /dtv/fnw_ok");
        }	

//Error: no fnw	
		if(!stat("/dtv/no_fnw", &sts))
        {
		sdl_draw_text_red(20,100+60, "ERROR: missing fnw.bin!",0, 1);
		usleep(1000*500);
		sdl_draw_text_yellow(20,100+80, "Please check instructions.",0, 1);
		usleep(1000*500); 
		sdl_draw_text_red(20,100+100 , "Rebooting...",0, 1);
		usleep(500*500); 
	//system("rm -rf /dtv/no_fnw");
        }		

//Progress: kernel:
    if(!stat("/dtv/Image_start", &sts))
        {
		sdl_draw_text_green(20,100+60, "Flashing kernel...",0, 1);
		usleep(500*500); 
//progress...
		sdl_draw_text_green(60,70, "******",0, 1);
	//system("rm -rf /dtv/Image_start");
        }	
						
    if(!stat("/dtv/Image_ok", &sts))
        {
		sdl_draw_text_green(20+280,100+60, "OK",0, 1);
		usleep(500*500); 
//progress...
		sdl_draw_text_green(60,70, "*******",0, 1);
	//system("rm -rf /dtv/Image_ok");
        }	

//Error: no Image	
		if(!stat("/dtv/no_Image", &sts))
        {
		sdl_draw_text_red(20,100+80, "ERROR: missing Image!",0, 1);
		usleep(1000*500);
		sdl_draw_text_yellow(20,100+100, "Please check instructions.",0, 1);
		usleep(1000*500); 
		sdl_draw_text_red(20,100+120 , "Rebooting...",0, 1);
		usleep(500*500);  
	//system("rm -rf /dtv/no_Image");
        }		
		
//Error: no exe.img.enc on usb		
	if(!stat("/dtv/exe_img_error", &sts))
        {
		sdl_draw_text_red(20,100+100, "ERROR: exe.img.enc not found!",0, 1);
		usleep(1000*500);
		sdl_draw_text_red(20,100+120, "Wrong or damaged firmware files.",0, 1);
		usleep(1000*500); 
		sdl_draw_text_red(20,100+140 , "Rebooting...",0, 1);
		usleep(500*500);  
	//system("rm -rf /dtv/exe_img_error");
        }	
		
//Progress: exe.img
    if(!stat("/dtv/exe_decr", &sts))
        {
		sdl_draw_text_green(20,100+80, "Decrypting exe.img...",0, 1);
		usleep(500*500); 
//progress...
		sdl_draw_text_green(60,70, "********",0, 1);
	//system("rm -rf /dtv/exe_decr");
        }	

							
    if(!stat("/dtv/exe_decr_ok", &sts))
        {
		sdl_draw_text_green(20+280,100+80, "OK",0, 1);
		usleep(500*500); 
//progress...
		sdl_draw_text_green(60,70, "**********",0, 1);	
	//system("rm -rf /dtv/exe_decr_ok");
        }		
		
//ERROR: exe.img crc failed
	if(!stat("/dtv/crc_error", &sts))
        {
		sdl_draw_text_red(20+280,100+80, "failed",0, 1);
		usleep(500*500); 
		sdl_draw_text_red(20,100+120, "ERROR: wrong checksums!",0, 1);
		usleep(1000*500);  
		sdl_draw_text_red(20,100+140, "Wrong or damaged firmware files.",0, 1);
		usleep(1000*500);  
		sdl_draw_text_red(20,100+160 , "Rebooting...",0, 1);
		usleep(500*500);  
	//system("rm -rf /dtv/crc_error");
        }	
	
    if(!stat("/dtv/exe_flash_start", &sts))
        {
		sdl_draw_text_green(20,100+100, "Flashing exe.img...",0, 1);
		usleep(500*500); 
//progress...
		sdl_draw_text_green(60,70, "***********",0, 1);
	//system("rm -rf /dtv/exe_flash_start");
        }	

							
    if(!stat("/dtv/exe_flash_ok", &sts))
        {
		sdl_draw_text_green(20+280,100+100, "OK",0, 1);
		usleep(500*500); 
//progress...
		sdl_draw_text_green(60,70, "*************",0, 1);	
	//system("rm -rf /dtv/exe_flash_ok");
        }
	
//Error: no appdata.img.enc on usb		
	if(!stat("/dtv/appdata_img_error", &sts))
        {
		sdl_draw_text_red(20,200+40, "ERROR: appdata.img.enc not found!",0, 1);
		usleep(1000*500); 
		sdl_draw_text_red(20,200+60, "Wrong or damaged firmware files.",0, 1);
		usleep(1000*500);  
		sdl_draw_text_red(20,200+80 , "Rebooting...",0, 1);
		usleep(500*500); 
	//system("rm -rf /dtv/appdata_img_error");
        }	
		
//Progress: appdata.img
    if(!stat("/dtv/appdata_decr", &sts))
        {
		sdl_draw_text_green(20,200+20, "Decrypting appdata.img...",0, 1);
		usleep(500*500); 
//progress...
		sdl_draw_text_green(60,70, "**************",0, 1);
	//system("rm -rf /dtv/appdata_decr");
        }	
							
    if(!stat("/dtv/appdata_decr_ok", &sts))
        {
		sdl_draw_text_green(20+280,200+20, "OK",0, 1);
		usleep(500*500); 
//progress...
		sdl_draw_text_green(60,70, "****************",0, 1);
	//system("rm -rf /dtv/appdata_decr_ok");
        }		
	
//ERROR: appdata.img crc failed
	if(!stat("/dtv/crc_error", &sts))
        {
		sdl_draw_text_red(20+280,200+20, "failed",0, 1);
		sdl_draw_text_red(20,200+60, "ERROR: wrong checksums!",0, 1);
		usleep(1000*500);
		sdl_draw_text_red(20,200+80, "Wrong or damaged firmware files.",0, 1);
		usleep(1000*500); 
		sdl_draw_text_red(20,200+100 , "Rebooting...",0, 1);
		usleep(500*500);   
	//system("rm -rf /dtv/crc_error");
        }	
	
    if(!stat("/dtv/appdata_flash_start", &sts))
        {
		sdl_draw_text_green(20,200+40, "Flashing appdata.img...",0, 1);
		usleep(500*500); 
//progress...
		sdl_draw_text_green(60,70, "*****************",0, 1);
	//system("rm -rf /dtv/appdata_flash_start");
        }	
								
    if(!stat("/dtv/appdata_flash_ok", &sts))
        {
		sdl_draw_text_green(20+280,200+40, "OK",0, 1);
		usleep(500*500); 
//progress...
		sdl_draw_text_green(60,70, "*******************",0, 1);
		usleep(500*500); 
	//system("rm -rf /dtv/appdata_flash_ok");
        }

						
	if(!stat("/dtv/5_end_ok", &sts))
        {
		sdl_draw_text_green(60,70, "********************",0, 1);
		sdl_draw_text_green(35,70, "[                     ] 100%",0, 1);	
		sdl_draw_text_yellow(20,200+70, "Done!",0, 1);
		usleep(1000*500);
	//system("rm -rf /dtv/5_end_ok");
		sdl_draw_text_blue(20,200+90, "TV is ready for SamyGO!",0, 1);
		usleep(1000*500);
		sdl_draw_text_red(20,200+110 , "Rebooting...",0, 1);
		usleep(1000*500);
        }


		
	
	
/*
    if(!stat("/dtv/stop", &sts))
       {
          playing=0; //stop for exit!!!
		
	//system("rm -rf /dtv/stop");
        }
*/		
// My code here END=================================


    //Blit the image to the backbuffer
    //SDL_BlitSurface(bg, &src, screen, &dest);
  
  }
	
	//Release the surface
	SDL_FreeSurface(bg);
	CleanUp();
     return 0;

}
