/** 
/** 
* @mainpage LOHA project
* @section Description 개요
* - 인터넷 위젯을 DTV에서 볼 수 있도록 개발하는 프로젝트 이며, 이 과제는 
* 최신 뉴스를 읽어들여 DTV에서 보여주는 위젯을 개발한다.
* @section Information  작성 정보
* - 작 성 자 : 서창교
* - 작성일자 : 2008/02/27
*/

/* B Series specified variables. Added by juzis28 */

var COMMON = "/mtd_down/common";
var GGAME_FOLDER = "/mtd_tlib/GGame";
var GGAME_CHILDREN_FOLDER = "/mtd_tlib/swf/CHILDREN";
var PLASMA_SWF_FOLDER = "/mtd_tlib/swf";
var MTD_RWAREA_FOLDER = "/mtd_rwarea";
var VERSION_0_PATH = "/mtd_rwarea/Version.0";
var VERSION_1_PATH = "/mtd_rwarea/Version.1";
var PARTITION_SWITCH_0= "/mtd_rwarea/PartitionSwitch_0_0";
var PARTITION_SWITCH_1= "/mtd_rwarea/PartitionSwitch_1_0";
var FFB_FOLDER = "FFB";
//var WIDGETAPPS_DIR = "/mtd_down/widgets/user/B_hack_widget/apps";
//var WIDGETDIR = "/mtd_down/widgets/user/B_hack_widget";
var WIDGETDIR = location.pathname.slice(0, - 10);
var WIDGETAPPS_DIR = WIDGETDIR + "apps";
//var path = location.pathname;
//path = path.slice(0, - 10);
//var WIDGETDIR = +this.widgetPath + this.widgetID
/*For testing purposes only*/
var TARGET_TESTDIR = "/mtd_swu";
var TESTFILE = "Version";
var PLATFORM_INFO = "/.info";


/*C series specific variables for widget hack. Need to change: var COMMON = "/mtd_rwcommon/common" */
var DUMMIE = "dummie.txt";
var ORIGINAL_HOTPLUG_FOLDER = "/sbin/usb_mount/";
var TARGET_HOTPLUG_FOLDER = "/mtd_rwarea/usb_mount";
var HOTPLUG_SH = "usb_hotplug.sh";
var USB_ROOT = "/dtv/usb/";
var USB_FOLDERS = [
                   "sda","sda1","sda2","sda3","sda4","sda5","sda6","sda7","sda8","sda9",
                   "sdb","sdb1","sdb2","sdb3","sdb4","sdb5","sdb6","sdb7","sdb8","sdb9", 
                   "sdc","sdc1","sdc2","sdc3","sdc4","sdc5","sdc6","sdc7","sdc8","sdc9", 
                   "sdd","sdd1","sdd2","sdd3","sdd4","sdd5","sdd6","sdd7","sdd8","sdd9",
                   "hda","hda1","hda2","hda3","hda4","hda5","hda6","hda7","hda8","hda9",
                   "hdb","hdb1","hdb2","hdb3","hdb4","hdb5","hdb6","hdb7","hdb8","hdb9", 
                   "hdc","hdc1","hdc2","hdc3","hdc4","hdc5","hdc6","hdc7","hdc8","hdc9", 
                   "hdd","hdd1","hdd2","hdd3","hdd4","hdd5","hdd6","hdd7","hdd8","hdd9"
                   ];                                                                   
var Devices = new Array();
var USB_FOLDER = "";
var RUN_SH = "run.sh";
var ErrorMsg = "";
var FilePlugind = null;
var SamyGOLink = "http://sourceforge.net/projects/samygo/files/SamyGO%20Extensions%20Packs/";
var SamyGoLinks = null;
var PlatformName = "";
var hotplug_script =
"\n"+
"if [ \"$ACTION\" = \"mount\" ] ; then\n"+
"    if [ -f $MOUNTBASEDIR/$PARTITION/run.sh ] ; then\n"+
"   chmod 777 $MOUNTBASEDIR/$PARTITION/run.sh\n"+
"#   exec $MOUNTBASEDIR/$PARTITION/run.sh $MOUNTBASEDIR/$PARTITION\n"+
"   sh -x $MOUNTBASEDIR/$PARTITION/run.sh $MOUNTBASEDIR/$PARTITION\n"+
"    fi\n"+
"fi\n";

var checkhack_script =
"#!/bin/sh\n"+
"touch $1/ScriptOK\n"+
"sync\n";

var RightsideMode = null;
var RightsideTitle = "Select Item";
/**
* @file      news.jsf
* @brief     위젯의 동작 및 화면을 제어하는 자바스크립트  
* @author   Changkyo Seo
* @date      27 Feb 2008 
*/
var lastFocusObj = null;
var DEBUG_MODE = "DEBUG";
var VER_INFO = "20080321001";
var categoryList = new Array();    //왼쪽메뉴 리스트 (카테고리리스트)


var gFocusSection = null;
var SECTION_CATEGORY = "category";
var SECTION_CONTENTS = "contents";
var SECTION_DETAIL = "detail";
var SECTION_LIST = "list";

var NEWS_COMMON_DIR = "news";
var NEWS_COMMON_FILE = "news/news.cfg"

var TIMER_RELOAD = 1000 * 60 * 10;
var TIMER_BUTTON_1 = 1000 * 30;

var Copy1,Copy2,Copy3,Copy4,Copy5; 

////////// Category Variable
var categoryListNum;    //category list의 갯수
var lastCategoryID;    //포커스가 category(왼쪽화면) 에서 contents(오른쪽화면)으로 이동시 마지막으로 포커스를 가지고 있던 SECTION_CATEGORY
var CATEGORY_PER_PAGE = 10;   //한페이지에서 보여주는 Category List 갯수
var CONTENTS_PER_PAGE = 9;    //한페이지에서 보여주는 contents 갯수
var categoryNum = 1;

////////// Contents Variable
var contentsListNum    //contents list의 갯수
var lastContentsID;    //포커스가 Contents(오른쪽화면) 에서 Detail(상세화면)으로 이동시 마지막으로 포커스를 가지고 있던 contetnsID
var contentsNum = 1;


var widgetXHRCategory = null;
var widgetXHRContents = null;

// 이미지 스크롤바 처리
var totalPage = 1;
var currentPage = 1;

//////////////////////////////////////////////
var contentsShowNum = 1;
//var MAX_NEWS_TITLE = 50;
//var MAX_NEWS_DETAIL= 45;
var browser = "Maple";

// 카테고리 전체페이지 (zero-based Index)
var totalCatePageNum;
var curCatePageNum;

var CONTENTS_PREV = -1;
var CONTENTS_NEXT = 1;

// To determine whether current category is showed
var varShowCurCategory = false;

var SCROLL_HEIGHT = "378"; //화면에 보여지는 실제 크기
var SCROLL_RATE = "1/6"; //키 한번에 움직이는 비율
var SCROLL_MOVE_HEIGHT = "63"; // 380/6 = 63.3
var SCROLL_POSITION = 0;
var SCROLL_REAL_HEIGHT = 0;
var bMaple = false;

// To enhance performance of news widget
var totalCategoryNum = 0;
var curLoadedCategoryNum = 0;
var curCategoryNum = 0;
var totalContentsArray = new Array();
var totalTitlesArray = new Array();


// To show loading images
var currentImg = 0;
var loadingImg;
var loadingTimer;
var initDataFlag = false;

var gReloadInstance = null;

//For Watch Dog
var pluginAPI = new Common.API.Plugin();
var bEnableWatchDog = true;
var watchDog = null;

var Category_Logo_list = new Array("usa_today_news.png",
                                    "usa_today_money.png",
                                    "usa_today_politics.png",
                                    "usa_today_life.png",
                                    "usa_today_sports.png",
                                    "usa_today_world.png"
                                    );

/**
 * @brief			Error Msg 처리
 * @remarks		Error Msg String 변수와 Blank 처리 Method
* @param		void
* @return       void
*/
var errorMsg = {
	not_available : "Not Available.",
	network : "Connection failed due to network problem.",
	service : "Unable to synchronize with service.",
	data : "A problem occured with the USA Today news server. Please try again later.",
	
	blank : function (number) {
		var tempStr = null;
		for (i=0;i<number;i++) tempStr += "-";
		return tempStr;
	}
}
function debug (str) {
	if (DEBUG_MODE == "DEBUG") {
		alert ("DEBUG >>> " + str);
	}
}
/**
 * @brief			XML http request ready state 값 검사
 * @remarks		XHR에서 status가 바뀔때 마다 호출이 되며, state가 done(4)이 되면 true를 리턴한다.
* @param		obj			XHR Object
* @return       void
*/
function checkReadyState(obj) {
    if (obj.readyState == 3) {
        // Watch Dog 실행을 중지시킨다.
        offWatchDog();
    } else if(obj.readyState == 4) {
        // Watch Dog을 실행시킨다.
        onWatchDog();
		if(obj.status == 200) 	{
			return true;
		}
		else 	{
			isPopup = true;
			openPopup (errorMsg.network, ReturnFocus, 5);
		    debug("Problem retrieving XML data");
		}
	} 
  return false;
}

 /**
 * @brief			Popup Callback
 * @remarks		로딩된 Data가 없으면 위젯을 종료하고 아니면 마지막 포커스로 이동
 * @param		button		팝업에서 입력된 버튼
 * @return       void
*/
 function popupCallback (button) {
 	isPopup = false;
	if (initDataFlag == false) {
		curWidget.hide();
		curWidget.setPreference("exit","true");
		//curWidget.destroy();
	} else {
		clearInterval (loadingTimer);
		document.getElementById("loadingImg").style.visibility = "hidden";
		if (gReloadInstance!=null) clearTimeout (gReloadInstance);
		gReloadInstance = setTimeout ("reloadContents()",TIMER_RELOAD);
		focus.go();
	}
}

 /**
 * @brief			Focus 관리
 * @remarks		현재 포커스와 마지막 포커스 저장 및 포커스 관련 Method
 * @param		void
 * @return       void
*/
function Focus () {
	this.last = null;
	this.cur = null;
	this.set = function (obj) {	
		this.last = this.cur;
		this.cur = obj;
	}
	this.get = function () { return this.cur;}
	this.go = function () {
		document.getElementById (this.cur.id).focus();
	}
}

var focus = new Focus();

// 090911 source change code
var Source = {
	originalSource : null,
	MEDIA : 0,
	ORIGINAL : 1,
}

Source.changeSource = function(source) {
    alert("Source : changeSource("+source+")");
	var TVMW = document.getElementById("pluginObjectTVMW");
	if (TVMW) {
		switch (source) {
			case this.MEDIA:
				alert("source change -> media source.");
				this.originalSource = TVMW.GetSource();
//				alert(this.originalSource);ddd
				TVMW.SetMediaSource();
				break;
			case this.ORIGINAL:
				if (this.originalSource != null) {
					alert("source change -> original source.");
					TVMW.SetSource(this.originalSource);
				}
				else {
					alert("original source not found.");
				}
				break;
			default :
				alert("default!");
				if (this.originalSource != null) {
					alert("source change -> original source.");
					TVMW.SetSource(this.originalSource);
				}
				else {
					alert("original source not found.");
				}
				break;
		}
	}
	else {
		alert("TVMW plugin not found.");
	}
}
//

/**
 * @brief			To make connection to XML for preloading
 * @remarks		XML 데이터가 성공적으로 받아진 경우 파싱하여 메모리에 저장한다.
* @param		void
* @return		void
*/
function XMLExceptionHandler () {
	debug ("XMLExceptionHandler()");
}


function showHiddenButtons () {
		document.getElementById ("moveButton").style.visibility = "visible";
		document.getElementById ("moveText").style.visibility = "visible";
		document.getElementById ("selectButton").style.visibility = "visible";
		document.getElementById ("selectText").style.visibility = "visible";
}

var widgetMode=null;
/**
 * @brief			HTML 코드에서 처음으로 호출하는 함수
 * @remarks		JS 안에서의 시작 함수를 호출한다.
* @param		void
* @return		void
*/
function func_onLoad(){
	// 090911 source change
	Source.changeSource(Source.MEDIA);
	//
	
	// 090911 위젯 깜빡임 현상 방지를 위해 setTimeout 을 사용함.
	setTimeout(function(){
		curWidget.setPreference('ready','true');
		//debug (VER_INFO);
		checkBrowser();
	    // watch dog 변수 설정
	    setWatchDog(document.embeds[1]);
		//document.getElementById("logo_in_list").style.visibility = "visible";

		initWidget();
		showWidget();
		
		//document.getElementById("loadingImg").style.visibility = "visible";
		alert("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"+categoryNum+"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		loadingTimer = setInterval("showLoading()",100);
		alert("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"+categoryNum+"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		//loadWidgetContents(widgetMode);
	}, 100)
}

/**
 * @brief			Widget 초기화 
 * @remarks		Widget 기본 환경 및 변수 초기화
* @param		void
* @return		void
*/
function initWidget() {
	debug ("initWidget()");
	gFocusSection = SECTION_CATEGORY;
	var FilePlugind = document.getElementById("pluginObjectFile");

  initLoadingImg();
}

/**
 * @brief			왼쪽메뉴에서의 키처리 함수
 * @remarks		키처리를 위해서는 포커스를 받고 있어야 한다.
* @param		obj		HTML object
* @return		void
*/
function func_inputKey(obj){
	var EKC = event.keyCode;
    var Idx = obj.name; //해당 Index 가져오기..
    var tmpCategoryID;
    //debug ("func_inputKey("+EKC+")");
	// 091126 '10년 동작 사양으로 주석처리
//    CommonLib.keyHandler(EKC, setLastFocus); 
    
   	switch(EKC) {
        //case(38) :		//Keyboard Up
		case(29460) :	//Wheel Up
		case(105) :		//Panel Up
		case(29468) :	//Wheeling Up
			//if(initDataFlag==false) return false;
			categoryNum--;
			if (Idx==1) {
				Idx = CATEGORY_PER_PAGE - 1;
				categoryNum = totalCategoryNum;	
			}
			Idx--;			
            if(Idx%CATEGORY_PER_PAGE==0) {
                createLeftSideHTML(Idx-1);
            }
            tmpCategoryID = SECTION_CATEGORY + Idx;
			document.getElementById(tmpCategoryID).focus();
			
			// Enter 처리
			lastCategoryID = obj.id;
        	gFocusSection = SECTION_CATEGORY;
			curCategoryNum = Idx - 1;
			//createRightSideHTML (Idx - 1);
        	break;

		//case(40) :		//Keyboard Down
        case(29461) :	//Wheel Down
		case(106) :		//Panel Down
		case(29469) :	//Wheeling Down
			//if(initDataFlag==false) return false;	
            // 오페라에서 안먹음 event.keyCode = "9"; //tab키의 keyCode값으로 변환       
			categoryNum++;
			if(Idx==categoryListNum){
				Idx = 0;
				categoryNum = 1;
			}
				
            Idx++;      
            if(Idx%CATEGORY_PER_PAGE==1) {
                createLeftSideHTML(Idx-1);
            }
            tmpCategoryID = SECTION_CATEGORY + Idx;
			
			// Enter 처리
			lastCategoryID = obj.id;
            gFocusSection = SECTION_CATEGORY;
			curCategoryNum = Idx - 1;
            //createRightSideHTML (Idx - 1);
			document.getElementById (tmpCategoryID).focus();
        	break;
        
        //case(39) :		//Keyboard Right
        case(5) :	//Wheel Right
		case(203) :		//Panel Right
		//case(13) :		//Keyboard Enter
		case(29443) :	//Wheel Enter
		case(612) :		//Pannel Source
        	//if(initDataFlag==false) return false;
 			varShowCurCategory = true;
			lastCategoryID = obj.id;
/*			gFocusSection = SECTION_CONTENTS;
            document.getElementById(lastContentsID).focus();*/
          DoMenuCommand(lastCategoryID);
       		break;
		       
        //case(27) :		//Keyboard ESC
        case(88) :		//Remocon Return
		case(613) :		//Panel Menu
			gFocusSection = SECTION_CATEGORY;
        	break;

		//case(33) :		//Keyboard Page Up
		case(69) :		//Remocon Rewind
			//if (initDataFlag==false) return false;
            if (Math.floor(Idx/CATEGORY_PER_PAGE)>0) {
                Idx-=CATEGORY_PER_PAGE;
                createLeftSideHTML(Idx-1);
            }
        	break;
        
        //case(34) :	//KeyboardPage Down
		case(72) :		//Remocon FF
			if(initDataFlag==false) return false;
            if(Math.floor((Idx-1)/CATEGORY_PER_PAGE)<Math.floor(categoryListNum/CATEGORY_PER_PAGE)) {
                for(i=0 ; i<CATEGORY_PER_PAGE ; i++) {
                    Idx++;
                }
                if(Idx>categoryListNum) {
                    Idx = categoryListNum;
                }
                createLeftSideHTML(Idx-1);
            }
       	 	break;
        
        default  : 
        	return false;
        break;
    }
}
/**
 * @brief			메뉴 항목에 포커스가 있을 때 화면 처리
 * @remarks		메뉴 바탕에 이미지를 배경으로 깔아서 포커스 효과를 나타낸다.
* @param		obj		HTML Object
* @return		void
*/
function menuFocus(obj,imageID){
	focus.set (obj);
	obj.style.border = "none";
	obj.style.color = "#FFFFFF";
	obj.style.backgroundImage = "url(img/left_list_highlight.png)";

    document.getElementById("lrButton").style.visibility = "hidden";
    document.getElementById("lrText").style.visibility = "hidden";
	document.getElementByName (imageID).src= "img/left_list_select.png";
}
/**
 * @brief			메뉴 항목에서 포커스를 벗어날 때 화면 처리
 * @remarks		메뉴 바탕에 이미지를 없애고 투명하게 만든다.
* @param		obj		HTML Object
* @return		void
*/
function menuBlur(obj,imageID){
	lastFocusObj = obj;
	obj.style.border = "none";
    obj.style.backgroundColor = "transparent";
	obj.style.backgroundImage = "";
	if (varShowCurCategory == true){
		document.getElementById (imageID).src= "img/left_list_select.png";
		obj.style.color = "#FFD800";
	} else {
		document.getElementById (imageID).src= "img/left_list_normal.png";
		obj.style.color = "#FFFFFF";
		
	}
	varShowCurCategory = false;

    document.getElementById("lrButton").style.visibility = "visible";
    document.getElementById("lrText").style.visibility = "visible";
}

/**
 * @brief			리스트 항목에 포커스가 있을 때 화면 처리
 * @remarks		리스트 바탕에 이미지를 배경으로 깔아서 포커스 효과를 나타낸다.
* @param		obj		HTML Object
* @return		void
*/
function listFocus(obj){
	focus.set (obj);
    obj.style.border = "none";
	obj.style.background = "transparent url('img/rss_list_highlight.png')";

}

/**
 * @brief			리스트 항목에서 포커스를 벗어날 때 화면 처리
 * @remarks		리스트 바탕에 이미지를 없애고 투명하게 만든다.
* @param		obj		HTML Object
* @return		void
*/
function listBlur(obj){
	lastFocusObj = obj;
    obj.style.border = "none";
	obj.style.backgroundImage = ""; 	
}

/**
 * @brief			오른쪽contents메뉴에서의 키처리 함수
 * @remarks		위, 아래 화살표를 누르면 하나씩 포커스가 이동하며, 페이지 업, 다운을 누르면 한페이지 단위로 이동한다.
* @param		 obj		HTML Object
* @return		void
*/
function right_inputKey(obj) {
	var EKC = event.keyCode;
    var Idx = obj.name; //해당 Index 가져오기..
    var tmpContentsID;
    //debug ("right_inputKey("+EKC+")");
	// 091126 '10년 동작 사양으로 주석처리
//    CommonLib.keyHandler(EKC,setLastFocus);
    contentsNum = Idx;
    
    switch(EKC) {
		// To block button 3
		case(29445) :
			//debug ("29445 is blocked.");
			blockNavigation(event);
			break;
		case(29460) :	//Wheel Up
		case(29468) :	//Wheeling Up
		case(105) :		//Panel Up(VOL_Up)
			blockNavigation(event);
        	gFocusSection = SECTION_CONTENTS;
			Idx-=1;
			contentsNum--;
			//화면이 전환되야 하는경우 새롭게 그려준다
            if (Idx>0) {
                if (Idx%CONTENTS_PER_PAGE==(CONTENTS_PER_PAGE - 1) || Idx%CONTENTS_PER_PAGE==0) {
                    createRightSideHTML(Idx - 1, curCategoryNum);
                } else {
					tmpContentsID = SECTION_CONTENTS + Idx;
	                document.getElementById(tmpContentsID).focus();	
				}
            }
			// For circulation
			else {
				Idx = contentsListNum;
				contentsNum = contentsListNum;
				//contentsNum = totalTitlesArray[categoryNum-1].length;
				createRightSideHTML(Idx -1, curCategoryNum);
			}
			debug("right_input :::: "+contentsNum);
			break;

		case(29461) :	//Wheel Down
		case(29469) :	//Wheeling Down
		case(106) :		//Panel Down(VOL_Down)
			blockNavigation(event);
            Idx++;      
			contentsNum++;
            if (Idx<=contentsListNum) {
                //화면이 전환되야 하는경우 새롭게 그려준다
                if (Idx%CONTENTS_PER_PAGE==1) {
                    createRightSideHTML(Idx - 1, curCategoryNum);
                }
                tmpContentsID = SECTION_CONTENTS + Idx;
                document.getElementById(tmpContentsID).focus();               
            }
			// For circulation
			else {
				Idx = 1;
				contentsNum = 1;
				createRightSideHTML(Idx-1,curCategoryNum);
			}
			debug("right_input :::: "+contentsNum);
			break;
        
		case(4) : 		//Wheel Left
		case(204) :		//Panel Left(CH_Down)
		case(88) :		//Remocon Return
		case(613) :		//Panel Menu
			blockNavigation(event);
            if (Idx>=0) {
				gFocusSection = SECTION_CATEGORY;
				lastContentsID = obj.id;
			    //debug("lastCategoryID : == : "+lastCategoryID);
			    document.getElementById(lastCategoryID).focus();
            }
	        break;
		
		case(29443) :	//Wheel Enter
		case(612) :		//Pannel Source
        	lastContentsID = obj.id;
			gFocusSection = SECTION_DETAIL;
			//createDetailInfoHTML(Idx);
      DoRightsideCommand(Idx-1);
	        break;
        
		case(69) :		//Remocon Rewind
			blockNavigation(event);
	    	gFocusSection = SECTION_CONTENTS;
	        if (Math.floor(Idx/CONTENTS_PER_PAGE)>0) {
                // 현재 위치가 2페이지이상일 경우 앞 페이지로 이동                
	            Idx-=CONTENTS_PER_PAGE;
				contentsNum = calculateIndexOfPage((Idx-1), CONTENTS_PER_PAGE);
                
                createRightSideHTML(contentsNum);
	        } else {
                // 현재 위치가 1페이지 일 경우 마지막 페이지의 첫번째 항목으로 포커스를 이동
				contentsNum = calculateIndexOfPage((contentsListNum-1), CONTENTS_PER_PAGE);
                createRightSideHTML(contentsNum);
            }
	        break;
        
		case(72) :		//Remocon FF
			blockNavigation(event);
			gFocusSection = SECTION_CONTENTS;
		    var tmp1 = Math.ceil(Idx/CONTENTS_PER_PAGE); // tmp1 : 현재 페이지  번호
		    var tmp2 = Math.ceil(contentsListNum/CONTENTS_PER_PAGE); // 다중 페이지 전체 페이지수
		    if (tmp1<tmp2) {
				Idx = CONTENTS_PER_PAGE * tmp1 + 1;
		        if (Idx>contentsListNum) {
		            createRightSideHTML(calculateIndexOfPage((contentsListNum-1), CONTENTS_PER_PAGE));
		        } else {
					contentsNum = Idx;
		            createRightSideHTML(Idx - 1);
		        }
			} else {
				contentsNum = 1;
			    createRightSideHTML(0);
			}
        	break;
        
		default  : 
            return false;
			break;
    }
}

/**
 * @brief			상세 화면에서의 키처리 함수 
 * @remarks		좌, 우 화살표는 이전, 다음 상세화면을 호출한다.
* @param		obj		HTML Object
* @return		void
*/
function detail_inputKey(obj) {
	var EKC = event.keyCode;
    var Idx = obj.name; //해당 Index 가져오기..
    var tmpContentsID;
    //debug ("detail_inputKey("+EKC+")");
	// 091126 '10년 동작 사양으로 주석처리
//    CommonLib.keyHandler(EKC, setLastFocus);
    
    switch(EKC) {
		case(29460) :	//Wheel Up
		case(29468) :	//Wheeling Up
		case(105) :		//Panel Up(VOL_Up)

        	break;
        
        case(29461) :	//Wheel Down
        case(29469) :	//Wheeling Down
		case(106) :		//Panel Down(VOL_Down)

        	break;

        case(4) : 		//Wheel Left
		case(204) :		//Panel Left(CH_Down)
        	break;
        
        case(5) :		//Wheel Right
		case(203) :		//Panel Right(CH_Up)
			break;
        
		case(88) :		//Remocon Return
		case(613) :		//Panel Menu
			changeWidgetTo (SECTION_LIST);
			tmpContentsID = lastContentsID;
			createRightSideHTML(contentsNum-1);
			document.getElementById(tmpContentsID).focus();
			showVerticalBar();
			gFocusSection = SECTION_CONTENTS;
			blockNavigation(event);
			break;
        
		case(29443) :	//Wheel Enter
		case(612) :		//Pannel Source
			break;
        
		case(8) :		//Back Space
	        break;
		
        default : 
            return false;
        break;
    }
}

/**
 * @brief			왼쪽의 메뉴 HTML을 작성
 * @remarks		이 함수가 호출될 때마다 innerHTML을 이용하여 동적으로 메뉴를 작성한다.
* @param		index		현재 선택한 메뉴의 Index, 0 base
* @return		void
*/
function createLeftSideHTML(index) {
	debug ("createLeftSideHTML()");
    var totalLine = null;
    totalLine = "<ul>";
	curCatePageNum = Math.floor(index/CATEGORY_PER_PAGE);
	//debug("curCatePageNum : "+curCatePageNum);
	if(totalCatePageNum > 0)
	{
		if(curCatePageNum == 0)
		{
			showUpArrow(false);
			showDownArrow(true);
		}
		else if(curCatePageNum < totalCatePageNum)
		{
			showUpArrow(true);
			showDownArrow(true);
		}
		else
		{
			debug(" subuparrow !!! ");
			showUpArrow(true);
			showDownArrow(false);
		}
	}
	//
    var maxI;
    if ((curCatePageNum+1)*CATEGORY_PER_PAGE > categoryListNum) {
        maxI = categoryListNum;
    }
	else {
        maxI = (curCatePageNum+1)*CATEGORY_PER_PAGE;
    }
/*    for ( i=((curCatePageNum)*CATEGORY_PER_PAGE); i<maxI ; i++) {
        var tmpID = SECTION_CATEGORY + (i+1);
		var imgID = "Image" + (i+1);
        var tmpIndex = i+1;
		var tmpLine = "<li><a id="+
			tmpID+" href=javascript: onkeydown=func_inputKey(this); onfocus= menuFocus(this,\'"+imgID+"\'); onblur=menuBlur(this,\'"+imgID+"\'); name="+
			tmpIndex+"><table cellspacing=0 cellpadding=0 width=100% border=0><tr><td width=40px style='padding-left: 15px;'><img src='img/left_list_"+(i==index?"select":"normal")+".png' name="+
			imgID+" id="+imgID+" style='display:block;'></td><td width=200px>" + categoryList[i] + "</td></tr></table></a></li>";
        totalLine += tmpLine;	
    }
    totalLine += "</ul>";
    document.getElementById('categoryList').innerHTML = totalLine;*/    
	lastCategoryID = SECTION_CATEGORY + '1';
    if (gFocusSection==SECTION_CATEGORY) {
        document.getElementById(SECTION_CATEGORY + (++index)).focus();
    }
	// Destroy all local variables
	totalLine = null; maxi = null; tmpID = null; imgID = null; tmpIndex = null; //maxi, tmpID, ingID는 지역변수.
}

/**
 * @brief			오른쪽의 리스트 HTML을 작성
 * @remarks		이 함수가 호출될 때마다 innerHTML을 이용하여 동적으로 리스트 화면을 작성한다.
* @param		index		현재 선택한 메뉴의 Index
* @return		void
*/
function createRightSideHTML(index) {
	debug ("createRightSideHTML("+index+")");
    var totalLine = null;
	totalLine = "<table height=39px cellspacing=0 cellpadding=0 width=100% border=0><tr><td align = center height = 39px background='img/rss_list_title_line.png'><font class='list_title'>"+RightsideTitle+"</font></td></tr></table>";
    totalLine += "<ul>";
    var tmpPage = index/CONTENTS_PER_PAGE; //전체페이지 구함

    tmpPage = Math.floor(tmpPage);
    var maxI;
    //Total Page와 CurrentPage 계산
	  contentsListNum = totalTitlesArray[curCategoryNum].length;
	
    totalPage = Math.ceil(contentsListNum/CONTENTS_PER_PAGE);
    currentPage = Math.ceil((index+1)/CONTENTS_PER_PAGE);
    scrollBar();
    
    if ((tmpPage+1)*CONTENTS_PER_PAGE > contentsListNum) {
        maxI = contentsListNum;
    } else {
        maxI = (tmpPage+1)*CONTENTS_PER_PAGE;
    }
	var i;
	
    for ( i=(tmpPage*CONTENTS_PER_PAGE) ; i<maxI ; i++) {
        lastContentsID = SECTION_CONTENTS + "1";
        if ((i%contentsShowNum)==0 && (i!=0)) {
            totalLine += "<ul>";
        }
		var tmpID = SECTION_CONTENTS + (i+1);
		var tmpIndex = i+1;
		tmpTitle = totalTitlesArray[curCategoryNum][i];
		//Problem could be happen, when the browser doesn't suppot ellipsis, at that time decide that do substring or ellipsis by browser version.
		tmpTitle = tmpTitle.replace(/<br>/,"");
			
		if (~i%2)
			tmpTitle = "<tr><td width=49px background='img/rss_list_text_line_1.png'></td><td width=556px align=left valign=top height=32px background='img/rss_list_text_line_1.png' style='vertical-align:middle;text-align:left;'><font class='list_name'><div>" + tmpTitle + "</div></font></td></tr>";
		else
			tmpTitle = "<tr><td width=49px background='img/rss_list_text_line_2.png'></td><td width=556px align=left valign=top height=32px background='img/rss_list_text_line_2.png' style='vertical-align:middle;text-align:left;'><font class='list_name'><div>" + tmpTitle + "</div></font></td></tr>";

		var tmpLine = null;	
		tmpLine = "<a id='"+
			tmpID+"' href ='javascript: void(0);' onkeydown='right_inputKey(this);' onfocus='listFocus(this);' onblur='listBlur(this);' name='"+
			tmpIndex+"'><table height=32px width=605px cellspacing=0 cellpadding=0 width=100% border=0>" +
			tmpTitle + 
			"</table></a>";
        totalLine += tmpLine;
	    if ((i%contentsShowNum)==(contentsShowNum-1) && (i+1)!=contentsListNum) {
            totalLine += "</ul>";
        }
    }
    document.getElementById('contentslist').innerHTML = totalLine;

  	if (gFocusSection==SECTION_CONTENTS) {
		index++;
        document.getElementById(SECTION_CONTENTS+index).focus();       
	}
	//debug ("gFocusSection : " + gFocusSection);
	debug ("createRightSideHTML("+index+") End.");
	// Destroy all local variables
	totalLine = null; tmpPage = null; maxl = null; i = null;
	tmpID = null; tmpIndex = null; tmpTitle = null; tmpLine = null; totalLine = null; 
}

/**
 * @brief			상세 보기 화면으로 가는 경우 포커스의 저장
 * @remarks		focus object 활용
* @param		obj		포커스를 받은 object
* @return		void
*/
function detailFocus (obj) {
	focus.set (obj);
}

/**
 * @brief			상세 보기 화면에서 포커스를 빼앗기는 경우 포커스의 저장
 * @remarks		focus object 활용
* @param		obj		포커스를 받은 object
* @return		void
*/
function detailBlur (obj) {
	lastFocusObj = obj;
}


/**
 * @brief           이미지 스크롤바 이동 
 * @remarks     이미지 스크롤바의 절대좌표 지정
 * @return      void
*/
function moveToForDetail(){
    document.getElementById("detaildrag").style.visibility="visible";
	document.getElementById("detaildrag").style.position = "absolute";
    document.getElementById("detaildrag").style.top = detailDragT + "px";
}

/**
 * @brief			이미지 스크롤바 위치 계산 
 * @remarks		전체 페이지와 현재 페이지 정보를 가지고 스크롤바의 위치를 계산
* @param		void
* @return		void
*/
function scrollBar() {
	//debug ("scrollBar()");
	 if (totalPage <= 1) {
        dragT = 0;
        document.getElementById("scroll").style.display = "none";//style.display="none" == 감춘다
        document.getElementById("listcount").innerHTML = "";
    } else {
        document.getElementById("scroll").style.display = "block";
        document.getElementById('listcount').innerHTML = currentPage+"/" + totalPage;
        if (currentPage==1) {
            dragT = 0;
        } else {
            dragT = Math.floor (((currentPage - 1)/(totalPage - 1)) * (349 - 39)); //(전체길이 - 이미지길이)
        }
        moveTo();
    }
}

/**
 * @brief			이미지 스크롤바 이동 
 * @remarks		이미지 스크롤바의 절대좌표 지정
* @param		void
* @return		void
*/
function moveTo() {
	document.getElementById("drag").style.top = dragT + "px";
    document.getElementById("drag").style.display="block";
}

/**
 * @brief			Widget에서 리스트 보기와 상세정보 보기 화면 전환
 * @remarks		리스트 보기와 상세보기 div 태그를 미리 정의 해 놓고 화면을 전환 
* @param		mode			리스트보기, 상세정보 보기 화면 선택, "front" - 리스트보기, "back" - 상세보기
* @return		void
*/
function changeWidgetTo(mode){
    switch (mode) {
        case SECTION_DETAIL:
            document.getElementById('logo_in_list').style.visibility = "hidden";
            document.getElementById('category_logo').style.visibility = "visible";
			document.getElementById('listview').style.display = "none";
			document.getElementById('listview').style.visibility = "hidden";
			document.getElementById('subtitle').style.visibility = "hidden";
			document.getElementById('listtitle').style.visibility = "hidden";
			document.getElementById('listcount').style.visibility = "hidden";
			document.getElementById('subup').style.visibility = "hidden";
			document.getElementById('category').style.visibility = "hidden";
			document.getElementById('categoryList').style.visibility = "hidden";
			document.getElementById('subdown').style.visibility = "hidden";
			document.getElementById('contents').style.visibility = "hidden";
			document.getElementById('contentslist').style.visibility = "hidden";
			
			document.getElementById('detailview').style.display = "block";			
			document.getElementById('subtitle2').style.visibility = "visible";
			document.getElementById('detail_title').style.visibility = "visible";
			document.getElementById('title').style.visibility = "visible";
			document.getElementById('detail_sub').style.visibility = "visible";
			document.getElementById('detail').style.visibility = "visible";
			document.getElementById('detailview').style.visibility = "visible";
			
			// Show scroll components of detail
			document.getElementById("detaildrag").style.visibility="visible";
			document.getElementById("detaildrag").style.position = "absolute";
		    document.getElementById("detaildrag").style.top = "0px";
			
			// Hiding all burden UI
			document.getElementById("digitalClock").style.visibility= "hidden";
			document.getElementById("moveButton").innerHTML = "<img src = 'img/help_up_down.png' width = '21' height = '27'>";
			document.getElementById("moveButton").style.left = "242px";
			document.getElementById("moveText").style.left = "274px";
	
			// hide LR Button
			document.getElementById("lrButton").style.visibility = "hidden";
			document.getElementById("lrText").style.visibility = "hidden";
			
			// hide select button
			document.getElementById("selectButton").style.visibility = "hidden";
			document.getElementById("selectText").style.visibility = "hidden";
			
			// Hide category list scroll
			document.getElementById("scroll").style.display="none";
		    document.getElementById("listcount").innerHTML="";
			
			// Hide category list middle line
			document.getElementById("subline").style.display="none";
        break;
    
        case SECTION_LIST:
			//document.getElementById('detailview').style.display = "none";	
            document.getElementById('logo_in_list').style.visibility = "visible";
            document.getElementById('category_logo').style.visibility = "hidden";
			document.getElementById('detailview').style.visibility = "hidden";
			document.getElementById('subtitle2').style.visibility = "hidden";
			document.getElementById('detail_title').style.visibility = "hidden";
			document.getElementById('title').style.visibility = "hidden";
			document.getElementById('detail_sub').style.visibility = "hidden";
			document.getElementById('detail').style.visibility = "hidden";

			document.getElementById('listview').style.visibility = "visible";
			document.getElementById('subtitle').style.visibility = "visible";
			document.getElementById('listtitle').style.visibility = "visible";
			document.getElementById('listcount').style.visibility = "visible";
			document.getElementById('category').style.visibility = "visible";
			document.getElementById('categoryList').style.visibility = "visible";
			document.getElementById('contents').style.visibility = "visible";
			document.getElementById('contentslist').style.visibility = "visible";
			
			document.getElementById("detailscroll").style.visibility = "hidden";
			document.getElementById("detaildrag").style.visibility="hidden";
			document.getElementById('listview').style.display = "block";
			
			// show LR Button
			document.getElementById("lrButton").style.visibility = "visible";
			document.getElementById("lrText").style.visibility = "visible";
			// show select button
			document.getElementById("selectButton").style.visibility = "visible";
			document.getElementById("selectText").style.visibility = "visible";

			document.getElementById("moveText").style.left = "190px";
			document.getElementById("moveButton").style.left = "158px";
			document.getElementById("moveButton").innerHTML = "<img src = 'img/help_up_down.png' width = '21' height = '27'>";			
			scrollBar();
        break;
    
        default:
        // do nothing
        break;
    }
}

function RememberFocus(object){
  focus.set(object);
  object.focus();
}

function ReturnFocus(button){
  focus.go();
}

function MakeMenu(){
                     
    var totalLine = "<ul>";
    
    var index = 0;
    var MenuItems = ["Install FFB apps","Unzip <b>game.zip</b> to TV","Get platform name","Enable GAME for plasma","Enable alternative FW"/*, "Copy hack from USB","Shell","Install SAE (test)","Copy hack from USB"*/];
    for (i = 0; i < MenuItems.length; i++){
    var tmpID = SECTION_CATEGORY + (i+1);
		var imgID = "Image" + (i+1);
    var tmpIndex = i+1;
		var tmpLine = "<li><a id="+
			tmpID+" href=javascript: onkeydown=func_inputKey(this,\'"+imgID+"\'); onfocus= menuFocus(this,\'"+imgID+"\'); onblur=menuBlur(this,\'"+imgID+"\'); name="+
			tmpIndex+"><table cellspacing=0 cellpadding=0 width=100% border=0><tr><td width=20px style='padding-left: 15px;'><img src='img/left_list_"+(i==index?"select":"normal")+".png' name="+
			imgID+" id="+imgID+" style='display:block;'></td><td width=200px>"+ MenuItems[i]+"</td></tr></table></a></li>";
    totalLine += tmpLine;	
    }
     
    totalLine += "</ul>";

    categoryListNum = MenuItems.length;
    CATEGORY_PER_PAGE = MenuItems.length;
    document.getElementById('categoryList').innerHTML = totalLine;  
    RememberFocus(document.getElementById(SECTION_CATEGORY + /*categoryNum*/"1"));  
  
}

function DoMenuCommand(id){
  RememberFocus(document.getElementById(id));

  //document.getElementById("loadingImg").style.visibility = "visible";

	offWatchDog();  // must be disabled otherwise TV reboots

  switch(id) {
    case SECTION_CATEGORY + "1":
      Unzip_FFB_To_TV();
      break;
    
    case SECTION_CATEGORY + "2":
      Unzip_Game_To_TV();  
      break;

    case SECTION_CATEGORY + "3":
      CheckPlatformName();     
      break;
    
    case SECTION_CATEGORY + "4":
      Enable_GAME_4plasmas();     
      break; 
	  
    case SECTION_CATEGORY + "5":
      Enable_AltFirmware();
      break;
/*
    case SECTION_CATEGORY + "6":
		CheckHack();
      break; 
*/
    default:
      openPopup("command:"+id,ReturnFocus,-1,"OK",null);
  }

//	onWatchDog();

  //document.getElementById("loadingImg").style.visibility = "hidden";
}

var XHRZip = null;
function OnLoadZip(){
  if (checkReadyState(XHRZip)){
    if(XHRZip.responseBody) 
      openPopup("responseBody exists!",ReturnFocus,-1,"OK",null);
    else
      openPopup("DownLoaded "+XHRZip.responseText.length+" bytes" ,ReturnFocus,-1,"OK",null);
  }
}

function DoRightsideCommand(idx){
 if(RightsideMode=="checkusb")
   DoCheckUsb(idx);
 else 
   DoDownloadZip(idx);
}

function DoDownloadZip(idx){

	offWatchDog();  // must be disabled otherwise TV reboots
            
  var link = SamyGoLinks[idx];
  link = link.replace("http://","http://citylan.dl.");
  link = link.replace(/\/download$/,"");
  link = link.replace("/projects","/project");
  link = link.replace("/files/","/");
   
  XHRZip = NewHttpRequest(link,OnLoadZip,true);

   onWatchDog();

  if(!XHRZip)
    ShowError();
  //openPopup(link,ReturnFocus,-1,"OK",null);
}

function ShowError(){
  if(ErrorMsg=="")
    ErrorMsg = "Unknown Error";
  openPopup("ERROR!: " + ErrorMsg,ReturnFocus,-1,"OK",null);
}

     
function addslash(dir){
 if(dir.charAt(dir.length-1) != '/')
  dir += "/";
 return dir;
}

function CheckCopy(file,dir){
 var result = FilePlugind.Copy(file,dir);
 if(result != 1){
  ErrorMsg = "Cannot copy " + file + " to " + dir +
   ". Error Code:" + result;
 }
 return result == 1;
}

function CheckDelete(file){
 var result = 1;
 if(FileExists(file)) 
  result = FilePlugind.Delete(file);
 if(result != 1){
  ErrorMsg = "Cannot delete " + file +
   ". Error Code:" + result;
 }
 return result == 1;
}

function FileExists(file){
 var result = (FilePlugind.IsExistedPath(file) == 1);
 return result;
}

function CheckFileExists(file){
 var result = FileExists(file);
 if(result){
  ErrorMsg = "File does not exists: " + file +
   ". Error Code:" + result;
 }
 return result;
}

function CheckReadTextFile(file){
 var result = GetTextFileContents(file);
 if(!result) {
  ErrorMsg = "Cannot read file: " + file;
 }
 return result;
}

function CheckWriteTextFile(file,contents){
 var result = WriteTextFileContents(file,contents);
 if(!result) {
  ErrorMsg = "Cannot write file: " + file;
 }
 return result;
}


function DoCheckHack(){
 if(!CheckHack())
   ShowError();
}
     
function DoRemoveHack(){
 if(Unhack())
   openPopup("Hack removed.",ReturnFocus,-1,"OK",null);
 else
   ShowError();
}     

function DoHack(){
 if(Hack())
  openPopup("Hack Installed. Now check if it works",ReturnFocus,-1,"OK",null);
 else
  ShowError();
}

var XHR = null;
function OnLoadSamyGOList(){
  if (checkReadyState(XHR) && XHR.responseText){
      var html = XHR.responseText;
      var Exp = new RegExp("<a href=\"[^\"]*zip[^\"]*download\"","ig");
      totalTitlesArray.length = curCategoryNum+1;
      totalTitlesArray[curCategoryNum] = new Array();
      SamyGoLinks = html.match(Exp);
      var platform = GetPlatformName();
      var PlatformLinks = new Array(); 
      for(var i = 0; i < SamyGoLinks.length;i++){
        if(SamyGoLinks[i].indexOf(platform)>=0)
          PlatformLinks.push(SamyGoLinks[i]);
      }                                    
      if(PlatformLinks.length>0)
        SamyGoLinks = PlatformLinks; 
      for(var i = 0; i < SamyGoLinks.length;i++){
         SamyGoLinks[i] = SamyGoLinks[i].substring(9,SamyGoLinks[i].length-1);    
         var Exp1 = /\/[^\/]*zip/ig;
         var title = SamyGoLinks[i].match(Exp1).toString();
         title = title.substr(1,title.length-1);
         title = title.replace(/%20/g," ");
         totalTitlesArray[curCategoryNum].push(title); 
      }
      //openPopup("link1:"+SamyGoLinks[0],ReturnFocus,1);
  	  gFocusSection = SECTION_CONTENTS;
			document.getElementById("loadingImg").style.visibility = "hidden";
      RightsideMode ="samygo";
      RightsideTitle = "Choose SamyGo AllExt version to install";
      createRightSideHTML(0);      
  } 
}
function DoInstallSamyGOAE(){
  var platform = GetPlatformName();
  openPopup("Your Platform is "+platform+". Continue?",SelectSmyGOAE,-1,"Yes","No");
}
  
function SelectSmyGOAE(button){
  if(button ==1)
    ReturnFocus();
  else {
   document.getElementById("loadingImg").style.visibility = "visible";
   XHR = NewHttpRequest(SamyGOLink,OnLoadSamyGOList,false);
   if(!XHR)
    ShowError();
  } 
}


function Hack(){
 var original = addslash(ORIGINAL_HOTPLUG_FOLDER)+HOTPLUG_SH;
 var intermediate = addslash(COMMON)+HOTPLUG_SH;         
 var usbfile = addslash(USB_FOLDER)+HOTPLUG_SH; 
 var target = addslash(TARGET_HOTPLUG_FOLDER)+HOTPLUG_SH;
 var result =
  CheckFileExists(original) &&
  CheckCopy(original,intermediate);
 if (result) {
  var script = CheckReadTextFile(HOTPLUG_SH);
  if(!script)
    return false;
  script += hotplug_script;
  result =
    CheckWriteTextFile(HOTPLUG_SH,script) &&
    //CheckCopy(intermediate,usbfile) && // to chmod +x , redundant
    //CheckCopy(usbfile,target) &&
    CheckCopy(intermediate,target) &&
    CheckDelete(intermediate);
 }
 return result;
}

function CreateRunSh(contents){
 var intermediate = addslash(COMMON)+ RUN_SH;
 var target = addslash(USB_FOLDER) + RUN_SH;
 return CheckWriteTextFile(RUN_SH,contents) &&
  CheckCopy(intermediate,target) &&
  CheckDelete(intermediate) &&
  CheckFileExists(target);
}

function CheckHack(){
 openPopup("Insert USB stick and press ok",CheckHackChooseUSB,-1,"OK",null);
 return true;
}

function CheckHackStep0(){
 var output = addslash(USB_FOLDER)+"ScriptOK";
 openPopupNoBt("Now copying script to USB",CheckHackStep1,10); //10 seconds - to ensure fs is synced
 var result =
  CreateRunSh(checkhack_script) &&
  CheckDelete(output);
 if(!result)
  ShowError();
}

function CheckHackStep1(){
 openPopup("Unplug USB stick and press ok",CheckHackStep2,-1,"OK",null);
}

function CheckHackStep2(){
 openPopup("Now Insert it again and press ok",CheckHackStep3,-1,"OK",null);
}

function CheckHackStep3(){
 openPopupNoBt("Now checking hack",CheckHackStep4,10); //10 seconds - to ensure script was run and files are written
}

function CheckHackStep4(){
 var output = addslash(USB_FOLDER)+"ScriptOK";
 if(CheckFileExists(output))
  openPopup("Congrat! Your TV is hacked :)",ReturnFocus,-1,"OK",null);
 else
  openPopup("Sorry! Check didn't work :(",ReturnFocus,-1,"OK",null);
}

function CheckHackChooseUSB(button){
   if(button == 1){
     ReturnFocus();
     return false;
   }
      totalTitlesArray.length = curCategoryNum+1;
      totalTitlesArray[curCategoryNum] = new Array();
      
      Devices = new Array();
      var i;
      for(i in USB_FOLDERS){                               
        var folder = USB_ROOT+USB_FOLDERS[i]; 
        if(FileExists(folder))
          Devices.push(folder);
      }                                    
      if(Devices.length == 0){
        openPopup("No Usb Devices Found.",CheckHackChooseUSB,-1,"Retry","Cancel");
        return false;
      }
        
      for(var i = 0; i < Devices.length;i++){
         totalTitlesArray[curCategoryNum].push(Devices[i]); 
      }
  	  gFocusSection = SECTION_CONTENTS;
			document.getElementById("loadingImg").style.visibility = "hidden";
      RightsideMode ="checkusb";
      RightsideTitle = "Choose usb device to write script";
      createRightSideHTML(0);
            
}

function DoCheckUsb(idx){
  if(idx < Devices.length){
    USB_FOLDER = Devices[idx];
    CheckHackStep0();
  }
  else
    openPopup("IDX = "+ idx+"devices:"+Devices.length,ReturnFocus,-1,"OK",null);

}

function Unhack(){
 var target = addslash(TARGET_HOTPLUG_FOLDER)+HOTPLUG_SH; 
 var result = CheckDelete(target);
 if(result && FileExists(target)){
   ErrorMsg = "Cannot remove Hack. Sorry.";
   return false;
 } 
 return result;
}

function DoFixUsb(){
  var result = FilePlugind.Copy(addslash(USB_FOLDER)+HOTPLUG_SH,addslash(TARGET_HOTPLUG_FOLDER)+HOTPLUG_SH);
  if(result != 1){
    ErrorMsg = "Cannot copy from " +USB_FOLDER + " code:"+result;
    ShowError();  
  }
  else
    openPopup("copied from:"+USB_FOLDER,ReturnFocus,-1,"OK",null);
} 
// Functions for B series  - start

function CheckExistingUSB(){
    var i;
    for(i in USB_FOLDERS){
    var folder = USB_ROOT+USB_FOLDERS[i];
    if(FileExists(folder))
    USB_FOLDER = folder;
    }
    return true;
}

function DoCopyGameToTV(){
	DoCopyGameToTV_Step1()
}

function DoCopyGameToTV_Step1(){
  openPopup("Place FFB directory on root of USB, connect to TV and confirm with OK<br><br>Continue?",DoCopyGameToTV_Step2,-1,"No","Yes");
}
// Isplesti funkcija iki direktorijos pasirinkimo ir direktoriju esanciu USB listo
function DoCopyGameToTV_Step2(button){
	if(button ==0)
    ReturnFocus();
  CheckExistingUSB();
  var result = FilePlugind.Copy(addslash(USB_FOLDER)+FFB_FOLDER,addslash(GGAME_FOLDER));
  if(result != 1){
    ErrorMsg = "Cannot copy from " +USB_FOLDER + " code: "+result;
    ShowError();  
	}
  else
    openPopup( "FFB copied from: "+USB_FOLDER + " to: " +GGAME_FOLDER,ReturnFocus,-1,"OK",null);
}
// ==================================================

	
function DoCopyFromUSB(){
  CheckExistingUSB(); 
  var result = FilePlugind.Copy(addslash(USB_FOLDER)+ TESTFILE,addslash(TARGET_TESTDIR)+ TESTFILE);
  if(result != 1){
    ErrorMsg = "Cannot copy from " +USB_FOLDER + " code: "+result;
    ShowError();  
  }
  else
    openPopup( TESTFILE+ " copied from: "+USB_FOLDER + " to: " +TARGET_TESTDIR,ReturnFocus,-1,"OK",null);
}     


// Nustatom aktyvia particija
function CheckCurrentFirmware(){
	CheckCurrentFirmware_0();
}

function CheckCurrentFirmware_0(){

	  FilePlugind.Delete(addslash(COMMON)+DUMMIE);
	  FilePlugind.Copy(VERSION_0_PATH, addslash(COMMON)+DUMMIE);
	    var text = GetTextFileContents(DUMMIE);
	if(text != "")
	curVersion = text;

	else
//	curVersion = "Unknown";	
	CheckCurrentFirmware_1();
}

function CheckCurrentFirmware_1(){

	  FilePlugind.Delete(addslash(COMMON)+DUMMIE);
	  FilePlugind.Copy(VERSION_1_PATH, addslash(COMMON)+DUMMIE);
	    var text = GetTextFileContents(DUMMIE);
	if(text != "")
	curVersion = text;
	else
	curVersion = "Unknown";
}


function Enable_AltFirmware(){
	CheckCurrentFirmware();
	openPopupNoBt("Checking firmware...",Enable_AltFw_Step1,2); 
}	


function Enable_AltFw_Step1(){
	if(curVersion != "Unknown")
	openPopup("Current version: " +curVersion +"<br>Do you realy want activate alternative firmware?",Enable_AltFw_Step2,-1,"No","Yes");
	else
	openPopup("Could not find firmware version.",ReturnFocus,-1,"OK",null);
}

function Enable_AltFw_Step2(button){
	if(button ==0)
    ReturnFocus();
	else {
	openPopupNoBt("Activating firmware...",Enable_AltFw_Step3,1);
	}
}
function Enable_AltFw_Step3(){

	if(FileExists(VERSION_0_PATH))
		var result = FilePlugind.Copy(VERSION_0_PATH,VERSION_1_PATH);
	else
		var result = FilePlugind.Copy(VERSION_1_PATH,VERSION_0_PATH);
		if(result != 1){
		ErrorMsg = "Cannot find any firmware ID. Error code: " +result;
		ShowError();  	
		}
		else
		openPopup( "Success!!! Now exit Internet@TV, go to: <br><b>Menu -> Support -> Software Upgrade</b><br>to roll back select <b>Alternative Software.</b><br><br> Important: menu shows the same fw version,<br> it is normal. True firmware version you can find<br> In Service Menu (first screen).",ReturnFocus,-1,"OK",null);
	
}

function Unzip_FFB_To_TV(){
Unzip_FFB_To_TV_Step_1();
}
function Unzip_FFB_To_TV_Step_1(){
  openPopup("Continue?",Unzip_FFB_To_TV_Step_2,-1,"No","Yes");
}

function Unzip_FFB_To_TV_Step_2(button){
	if(button ==0)
    ReturnFocus();
	else {
	openPopupNoBt("Installing FFB apps...",Unzip_FFB_To_TV_Step_3,1);
	}
}

function Unzip_FFB_To_TV_Step_3(){
		var result = FilePlugind.Unzip(addslash(WIDGETAPPS_DIR)+"FFB.zip",addslash(GGAME_CHILDREN_FOLDER));
		if(result != 1){
		ErrorMsg = "Cannot unzip FFB.zip"+ ", code: "+result;
		ShowError();  
						}
		else
		openPopup( "FFB apps installed to " + GGAME_CHILDREN_FOLDER + "<br>Apps are located at:<br> <b>Content management -> My Content -> Children</b><br> More info on samygo.tv forum.",ReturnFocus,-1,"OK",null);

 }
 
 function Unzip_Game_To_TV(){
	Unzip_Game_To_TV_Step_1();
}

function Unzip_Game_To_TV_Step_1(){
  openPopup("Rename archive to <b>game.zip</b>, place on root of USB, connect to TV and press YES<br><br>Continue?",Unzip_Game_To_TV_Step_2,-1,"No","Yes");
}


function Unzip_Game_To_TV_Step_2(button){
	if(button ==0)
    ReturnFocus();
	else {
	openPopupNoBt("Searching for <b>game.zip</b> on USB...",Unzip_Game_To_TV_Step_3,1);
	}
}
 
function Unzip_Game_To_TV_Step_3(){
 	CheckExistingUSB();
	var result = FileExists(addslash(USB_FOLDER)+ "game.zip")
 	if(result != 1){
		ErrorMsg = addslash(USB_FOLDER)+ "game.zip" + "<br> File not found";
		ShowError(); 
		}	
	else{ 
	openPopupNoBt("Extracting file...",Unzip_Game_To_TV_Step_4,1);
	}
 }
 
function Unzip_Game_To_TV_Step_4(){
		var result = FilePlugind.Unzip(addslash(USB_FOLDER)+ "game.zip",addslash(GGAME_CHILDREN_FOLDER));
			if(result != 1){
				if(result == -5){
					ErrorMsg = "Cannot unzip " +addslash(USB_FOLDER)+ "game.zip" + "<br> File not found";
					ShowError(); 
					}
				else if(result == -7){
					ErrorMsg = "Cannot unzip " +addslash(USB_FOLDER)+ "game.zip" + "<br> No permissions";
					ShowError(); 
					}	
				else if(result == 0){
					ErrorMsg = "Cannot unzip " +addslash(USB_FOLDER)+ "game.zip" + "<br> No space on device left";
					ShowError(); 
					}						
				else{
					ErrorMsg = "Cannot unzip " +addslash(USB_FOLDER)+ "game.zip" + "<br> code: "+result;
					ShowError();  
					}
				}		
			else{
				openPopup( "Success!!! File extracted to " + GGAME_CHILDREN_FOLDER + "<br>You can find it at:<br> <b>Content management -> My Content -> Children</b><br><br>More info on samygo.tv forum.",ReturnFocus,-1,"OK",null);
			}

 }

//var result = FilePlugind.Unzip(WIDGETDIR + "symlinks/syml_mtd_rwarea.zip", WIDGETDIR);	
function Enable_GAME_4plasmas(){
	openPopup("Do you want to enable GAME menu for your plasma TV?",Enable_GAME_4plasmas_Step_2,-1,"No","Yes");
}

function Enable_GAME_4plasmas_Step_2(button){
	if(button ==0)
    ReturnFocus();
	else {
	openPopupNoBt("Enabling <b>GAME</b> menu...",Enable_GAME_4plasmas_Step_3,1);
	}
}

function Enable_GAME_4plasmas_Step_3(){
//  var result = FilePlugind.Unzip(addslash(USB_FOLDER)+ "GAME_symlink_for_plasmas.zip",PLASMA_OTHERS_FOLDER);
  var result = FilePlugind.Unzip(addslash(WIDGETDIR) + "symlinks/GAME_symlink_for_plasmas.zip",addslash(PLASMA_SWF_FOLDER));	
    if(result != 1){
    ErrorMsg = "Can not enable GAME for plasma"+ ", code: "+result;
    ShowError();  
  }
   else
	openPopup( "GAME is successfully enabled ! Go to:<br> <b>Content management -> My Content -> OTHERS -> GAMES</b> <br>Here you`ll find your SamyGO apps. <br><br>More info on samygo.tv forum.",ReturnFocus,-1,"OK",null);
}

// Functions for B series  - end

function GetTextFileContents(filename){
  var fs = new FileSystem();
  var fp = fs.openCommonFile(filename, "r");
			
  if(fp) {
				
    var strLine;
    var cont = "";
    cont = fp.readAll();
    fs.closeFile(fp);                     
    return cont.replace(/\r\n/g, "\n");
  }
  else {   
    return false;
  } 
}


function WriteTextFileContents(filename,contents){
  var fs = new FileSystem();
  var fp = fs.openCommonFile(filename, "w");
		
  var result = false;	
  if(fp) {
				
    var strLine;
    var cont = "";
    result = fp.writeAll(contents);
    fs.closeFile(fp);                     
  }
  return result;
}

function NewHttpRequest(url,OnLoad,binary) {
		var XHR = null;
    if (window.XMLHttpRequest) 	{
      XHR = new XMLHttpRequest();
    }	else if (window.ActiveXObject) {
        XHR = new ActiveXObject("Microsoft.XMLHTTP");
    }             
		if (XHR!=null) {
      XHR.onreadystatechange = OnLoad; 
	 		XHR.open("GET",url,true);
      if (binary)
        XHR.overrideMimeType("application/zip");  

	  	XHR.send(null);
	  }
		else 	
	  	ErrorMsg ="Your browser does not support XMLHTTP.";
    return XHR;
}

function CheckPlatformName(){
	openPopupNoBt("Checking platform name...",CheckPlatformName_Step_1,1);
}

function CheckPlatformName_Step_1(){
 var platform = CheckPlatformName_Step_2();
//	var platform = GetPlatformName() ;
	openPopup("Your Platform is "+platform,ReturnFocus,-1,"OK",null);
}

function CheckPlatformName_Step_2(){
 if(!PlatformName){
  FilePlugind.Delete(addslash(COMMON)+DUMMIE);
  FilePlugind.Copy(PLATFORM_INFO,addslash(COMMON)+DUMMIE);
  var text = GetTextFileContents(DUMMIE);
  FilePlugind.Delete(addslash(COMMON)+DUMMIE);
  if(text)
   PlatformName = text;
  else
   PlatformName = "Unknown";
 } 
 return PlatformName;
}

/*// Isfiltruoja Version.1
function GetPlatformName(){
 if(!PlatformName){
  FilePlugind.Delete(addslash(COMMON)+DUMMIE);
  FilePlugind.Copy("/mtd_rwarea/Version.1",addslash(COMMON)+DUMMIE);
  var text = GetTextFileContents(DUMMIE);
  FilePlugind.Delete(addslash(COMMON)+DUMMIE);
  if(text){
   var Exp = new RegExp("_[^_]+_","");
   text = Exp.exec(text).toString();
  }                      
  if(text)
    text = text.substr(1,text.length-2);
  if(text)
   PlatformName = text;
  else
   PlatformName = "Unknown";
 } 
 return PlatformName;
}
*/
//*/


/**
 * @brief			Show widget division
 * @remarks		Make style of widget components visible
* @param		void
* @return		void
*/
function showWidget() {
	debug ("showWidget()");
	document.getElementById("sub_bg").style.visibility = "visible";
	document.getElementById("subtitle")	.style.visibility = "visible";
	document.getElementById("subline").style.visibility = "visible";

	FilePlugind = document.getElementById("pluginObjectFile");

  //AddText(getFileContents("news/usb_hotplug.sh"));
  MakeMenu();

//  openPopup("TEST("+Copy3+","+Copy4+","+Copy1+")",ReturnFocus,15,"OK",null);
  	
}

/**
 * @brief			세로선 숨기기
 * @remarks		화면 UI 조정을 위한 함수
* @param		void
* @return		void
*/
function hideVerticalBar() {
	document.getElementById("subline").style.display="none";
}

/**
 * @brief			세로선 보이기
 * @remarks		화면 UI 조정을 위한 함수
* @param		void
* @return		void
*/
function showVerticalBar() {
	document.getElementById("subline").style.display="block";	
}

/**
 * @brief			브라우저 타입 확인
 * @remarks		IE, Opera, Maple 브라우저 구분함수 browser 전역변수에 등록함
 * @param		void
 * @return	 	void
*/
function checkBrowser()
{
	if(navigator.appName == "Microsoft Internet Explorer") {
		browser = "IE";
	}
	else if(navigator.appName == "Opera")
	{
		browser = "Opera";
	}
	else {
		browser = "Maple";
		bMaple = true;
	}
}

/**
 * @brief			키 이벤트를 위젯이 처리하고 상위로 전달하지 않는다 
 * @remarks		최상위 화면이 아닌 경우에는 복귀키를 위젯에서만 처리하고 N Navi로 전달하지 않기위해 이 함수를 호출한다.
 * @param		event	System Event
 * @return	 	void
*/
function blockNavigation(event)
{
	if( browser == "Maple" )	
    	event.preventDefault();
}
/**
 * @brief			위쪽 화살표 보이기
 * @remarks		내용이 화면에 넘칠 경우 나타나야하는 위쪽 화살표를 보여줌
 * @param		bShow		boolean
 * @return	 	void
*/
function showUpArrow(bShow) {
	if(bShow) {
		document.getElementById('subup').style.visibility= "visible";
	}
	else {
		document.getElementById('subup').style.visibility = "hidden";
	}
}
/**
 * @brief			아래쪽 화살표 보이기
 * @remarks		내용이 화면에 넘칠 경우 나타나야하는 아래쪽 화살표를 보여줌
 * @param		bShow		boolean
 * @return	 	void
*/
function showDownArrow(bShow) {
	if(bShow)
	{
		document.getElementById('subdown').style.visibility = "visible";
	}
	else
	{
		document.getElementById('subdown').style.visibility = "hidden";
	}
}


/**
 * @brief			loading에 사용되는 이미지 초기화
 * @remarks		빠른 수행을 위하여 미리 로딩해 놓음
* @param		void
* @return		void
*/
function initLoadingImg() {
	loadingImg = new Array();
	var imgName = "loading_";
	var imgIndex = "01";
	var ext = ".png";
	for ( i=0; i<12; i++) {
		if ( i < 9 ) {
			imgIndex = "0"+(i + 1);
		} else {
			imgIndex = ""+(i + 1);
		}
		loadingImg[i] = new Image();
		loadingImg[i].src = "img/" + imgName + imgIndex + ext;
	}
	document.getElementById("loadingImg").src = loadingImg[currentImg].src;	
}

/**
 * @brief			로딩중 이미지 표시 
 * @remarks		로딩 명령을 내리고 명령이 완료할때까지 이 함수를 0.1초 간격으로 호출
 * @param		void
 * @return	 	void
*/
function showLoading() {
	if ( currentImg == loadingImg.length )
		currentImg = 0;
	document.getElementById("loadingImg").src = loadingImg[currentImg].src;
	currentImg++;
}

function abortAllXHR () {
	debug ("abortAllXHR");
	if (widgetXHRCategory != null) widgetXHRCategory.abort();
	for (var i=0;i<categoryListNum;i++)
		if (widgetXHRContents[i] != null) widgetXHRContents[i].abort();
}

function onUnLoad() {
	debug ("onUnLoad()");
	// 090911 source change
	Source.changeSource(Source.ORIGINAL);
	//
	//abortAllXHR();
	if( bEnableWatchDog == false ) {
		onWatchDog();
//		enableWatchDog();
	}
}

// ===================================
// Watch Dog
// ===================================
function setWatchDog(obj) {
    // watch dog 변수 설정
    watchDog = obj;
    watchDogStatus = true;
}

function onWatchDog() {
    if( bMaple ) {
		if( bEnableWatchDog == false ) {
			pluginAPI.setOnWatchDog();
			bEnableWatchDog = true;
		}
	}
}

function offWatchDog() {
    if( bMaple ) {
		if( bEnableWatchDog ) {
			pluginAPI.setOffWatchDog();
			bEnableWatchDog = false;
		}
	}
}

// ===================================
// 유틸리티
// ===================================
function  calculateIndexOfPage(curIndex, pageNum) {
    var resultIndex = 0;
    resultIndex = Math.floor(curIndex/pageNum);
    resultIndex *= pageNum;
    
    return resultIndex;
}

// 091126 '10년 동작 사양으로 주석처리
//function setLastFocus() {
//	lastFocusObj.focus();
//}


		
function parseloadCateNum(fp) {
	var strLine, strArr;
	var loadCateNum = null;
	while( ( strLine=fp.readLine() ) ) {
		strLine = strLine.trim();
		if( strLine.charAt(0) != '#' ) {
			strArr = strLine.split("=", 2);
			if( strArr[0] == 'curShowCategoryNum' ) {
				loadCateNum = strArr[1];
				break;
			}
		}
	}
	return loadCateNum;
}

String.prototype.trim = function() {
    return (this.replace(/^\s+|\s+$/g, ""));
}
////////////////////////////////////////////////////
